#!/bin/sh

# Copyright (c) 2016 Samsung Electronics Co., Ltd All Rights Reserved
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Script to run all testsuite packages available in given directory.
#
# Syntax is: run_tct.sh $ID
#
# Author: Aleksander Mistewicz <a.mistewicz@samsung.com>

TESTLAB_SCRIPTS="$(CDPATH='' cd -- "$(dirname -- "$0")/.." && pwd -P)"

. "${TESTLAB_SCRIPTS}/common.sh"
. "${TESTLAB_SCRIPTS}/run/run.sh"

ID="$1"

test -n "${ID}" || die "Missing argument: id"

TEST_REPO="${NATIVE_TCT_HOST_PATH}/packages/"
TEST_PLAN="${NATIVE_TCT_HOST_PATH}/shell/tmp-${ID}"

create_testplan "${TEST_PLAN}" "${TEST_REPO}"
run_testplan "${TEST_PLAN}" "${ID}"

rm "${TEST_PLAN}"
